--delete from c6mart.gestione_Email where data_Generazione > getDate()-1
--truncate table log_esecuzione
--select * from log_esecuzione
CREATE procedure [C6Mart].[temp_RP_DM_GestioneEmail] 
AS
BEGIN
BEGIN TRANSACTION
--QUESTA SP POPOLA LA TABELLA GESTIONE_EMAIL PER LE CASISTICHE DI:
--	PERFEZIONAMENTO;
--	MANCATA MIGRAZIONE;
--	REINVIO SOLLECITO MANCATA MIGRAZIONE.
--LA GESTIONE DELLE EMAIL PER LE RISORSE NON ASSOCIATE AD AREE DI BISOGNO O
--PER REINVIO DEL SOLLECITO PER LE RISORSE NON ASSOCIATE AD AREE DI BISOGNO 
--VIENE FATTA DOPO L'ALLINEAMENTO CON I DATI DEL SIMPB
--ESTRAZIONE EMAIL PERFEZIONAMENTO
--TIPO EMAIL: "PERF"
--L'EMAIL VIENE INVIATA PER TUTTI I CLIENTI CHE HANNO DATA DI PERFEZIONAMENTO VALORIZZATA
--IL CONTROLLO SULLA DATA DI GENERAZIONE >= DELLA DATA DI PERFEZIONAMENTO E' DOVUTO AL
--FATTO CHE IL CONTRATTO PUO` ESSERE CHIUSO E RIAPERTO ED IN QUESTO CASO LA MAIL DI PERFEZIONAMENTO
--DEVE ESSERE REINVIATA
-- EMAIL DI ADESIONE AL SERVIZIO SEI
-- TIPO EMAIL 'PERF'
DECLARE @NUMGIORNIDALPERF SMALLINT
DECLARE @NUMGIORNIDASOLLECITO SMALLINT
DECLARE @ID_ELAB INT
DECLARE @MaxInvioSoll as SMALLINT
SET @MaxInvioSoll = CAST(dbo.getParametro('MaxInvioSoll') as smallint)
SET @ID_ELAB = C6MART.GETIDELAB()
SET @NUMGIORNIDALPERF = CAST(dbo.getParametro('NUMGIORNIDALPERF') as smallint) --7
SET @NUMGIORNIDASOLLECITO = CAST(dbo.getParametro('NUMGIORNIDASOLLECITO') as smallint) --7
-- Log esecuzione
INSERT INTO LOG_ESECUZIONE(Nome, Inizio, Nota) 
	VALUES ('RP_DM_GestioneEmail - Mail Perf',GETDATE(),'Elaborazione giornaliera')
--0. MODIFICO I RECORD IN GESTIONE EMAIL CON TIPO = PERF PER EVITARE IL REINVIO MULTIPLO A SEGUITO DELLA RIATTIVAZIONE 
UPDATE C6MART.GESTIONE_EMAIL
SET TIPO = 'OLD'
FROM C6MART.Gestione_EMAIL EMAIL
	INNER JOIN C6MART.VCONTRATTI VC
	   ON VC.COD_FISCALE = EMAIL.COD_FISCALE
	   AND VC.rete = EMAIL.RETE
	   AND EMAIL.TIPO = 'PERF'
    INNER JOIN [C6Mart].[CONTRATTOSEI_METADATI]  MC
       ON VC.chiaveClientePB = MC.CHIAVECLIENTEPB
       AND VC.riattivazione = 1 AND VC.DATA_FINEAVANZATO = '9999-12-31 00:00:00.000' 
       AND MC.Tip_riattivazione = 1
--1. INSERIMENTO MAIL DI "PERFEZIONAMENTO"
-- TUPLE DA PERFEZIONARE SU CONTRATTOSEI
-- NON PRESENTI SU GESTIONE_EMAIL
INSERT INTO C6Mart.GESTIONE_EMAIL
	(Rete,Cod_Fiscale,Tipo,Data_Generazione, ID_ELAB)
SELECT 
	VC.Rete,
	VC.Cod_Fiscale,
	'PERF' as TipoEmail,
	GETDATE() AS DataGenerazione,
	@ID_ELAB AS ID_ELAB
FROM C6Mart.VCONTRATTI VC
INNER JOIN C6Mart.CONTRATTOSEI_METADATI MD
		ON MD.ChiaveClientePb = VC.ChiaveClientePb
LEFT JOIN C6Mart.GESTIONE_EMAIL EMAIL
	ON VC.RETE = EMAIL.RETE
	AND VC.COD_FISCALE = EMAIL.COD_FISCALE
	AND EMAIL.TIPO = 'PERF'						
	AND EMAIL.Data_Generazione >= VC.Data_Perf	-- CONDIZIONE PER ESCLUDERE DAL JOIN UN CONTRATTO CHIUSO E RIAPERTO.
LEFT JOIN C6MART.CODICI_PROMOTORI_FITTIZI PF	-- IN QUESTO MODO LO INSERIAMO NUOVAMENTE IN GESTIONE_MAIL.
	ON VC.COD_AGENTE BETWEEN PF.CODICEDA AND PF.CODICEA
	AND VC.RETE = PF.RETE
WHERE 1 = 1
	--AND VC.InvioBenvenuto = 'N'
	AND VC.Data_FineAvanzato > getDate()
	--AND VC.GenerazioneReport = 'S'
	AND EMAIL.COD_FISCALE IS NULL
	AND PF.RETE IS NULL
-- Log esecuzione
UPDATE LOG_ESECUZIONE
SET	Fine = GETDATE(),Tipo = 'INSERT',Righe = @@ROWCOUNT
WHERE Nome = 'RP_DM_GestioneEmail - Mail Perf' AND
	Inizio = (SELECT MAX(Inizio) FROM LOG_ESECUZIONE WHERE Nome = 'RP_DM_GestioneEmail - Mail Perf')
INSERT INTO LOG_ESECUZIONE (Nome, Inizio, Nota)
	VALUES ('RP_DM_GestioneEmail - SollecitiNOMIG',GETDATE(),'Elaborazione giornaliera')
-- 2. INSERIMENTO MAIL "SOLLECITI"
-- TUPLE DA PERFEZIONARE SU CONTRATTOSEI
-- E PRESENTI SU GESTIONE_EMAIL
-- IL PB NON HA EFFETTUATO LA MIGRAZIONE
-- N.B. PER IL PRIMO SOLLECITO DATA_ULTIMOSOLLECITO è NULL -> CONSIDERIAMO DATA_PERF
INSERT INTO C6Mart.GESTIONE_EMAIL
	(Rete,Cod_Fiscale,Tipo,Data_Generazione,ID_ELAB)
SELECT 
	VC.rete,
	VC.cod_fiscale,
	CASE 
		WHEN ISNULL(MD.numSolleciti,0) = 0 THEN '1_SOLL_NOMIG'
		WHEN MD.numSolleciti = 1 THEN '2_SOLL_NOMIG'
		WHEN MD.numSolleciti = 2 THEN '3_SOLL_NOMIG'
		ELSE 'S_SOLL_NOMIG'
	END as tipoEmail,
	getDate() as DataGenerazione,
	@ID_ELAB AS ID_ELAB
FROM C6Mart.VCONTRATTI VC
INNER JOIN [C6Mart].[CONTRATTOSEI_METADATI] MD
		ON MD.chiaveclientepb = VC.chiaveclientepb
--LEFT JOIN C6MART.GESTIONE_EMAIL EMAIL
--	ON VC.RETE = EMAIL.RETE
--	AND VC.COD_FISCALE = EMAIL.COD_FISCALE
    --AND EMAIL.DATA_GENERAZIONE < getDate()
LEFT JOIN C6MART.CODICI_PROMOTORI_FITTIZI PF
	ON VC.COD_AGENTE BETWEEN PF.CODICEDA AND PF.CODICEA
	AND VC.RETE = PF.RETE
WHERE 1 = 1
	AND MD.numSolleciti < @MaxInvioSoll
	AND (
			(ISNULL(MD.numSolleciti,0) = 0 AND DATEDIFF(DAY,VC.Data_Perf,GETDATE()) >= @NUMGIORNIDALPERF)
			 OR
			(DATEDIFF(DAY,isnull(MD.Data_UltimoSollecito,GETDATE()),GETDATE()) >= @NUMGIORNIDASOLLECITO)
		)
	AND MD.clienteMigrato = 'N'
	AND MD.InvioBenvenuto = 'N' 
	AND VC.Data_FineAvanzato > getDate()
--	AND (EMAIL.COD_FISCALE IS NULL OR EMAIL.INVIATA = 'S')
	AND PF.RETE IS NULL
    AND VC.COD_FISCALE = 'TSSDNI82P44A984U'
-- 2.BIS UPDATE CONTRATTOSEI DOPO INSERIMENTO MAIL "SOLLECITI"
-- AUMENTIAMO IL NUMERO numSolleciti
-- AGGIORNIAMO LA DATA Data_UltimoSollecito
UPDATE 
	c6mart.[CONTRATTOSEI_METADATI]
SET 
	numSolleciti = isnull(numSolleciti,0) + 1,
	Data_UltimoSollecito = getDate()
FROM C6Mart.vcontratti VC
INNER JOIN [C6Mart].[CONTRATTOSEI_METADATI] MD
		ON MD.ChiaveClientePb = VC.ChiaveClientePb
LEFT JOIN C6MART.CODICI_PROMOTORI_FITTIZI PF
	ON VC.COD_AGENTE BETWEEN PF.CODICEDA AND PF.CODICEA
	AND VC.RETE = PF.RETE
WHERE 1 = 1
	AND MD.numSolleciti < @MaxInvioSoll
	AND (
			(ISNULL(MD.numSolleciti,0) = 0 AND DATEDIFF(DAY,VC.Data_Perf,GETDATE()) >= @NUMGIORNIDALPERF)
			 OR
			(DATEDIFF(DAY,isnull(MD.Data_UltimoSollecito,GETDATE()),GETDATE()) >= @NUMGIORNIDASOLLECITO)
		)
	AND MD.clienteMigrato = 'N'
	AND MD.InvioBenvenuto = 'N' -- richiesto da Tringali per non inviare mail se report già inviato
	AND VC.Data_FineAvanzato > getDate()
	--AND VC.GenerazioneReport = 'S'
	AND PF.RETE IS NULL
	AND VC.COD_FISCALE = 'TSSDNI82P44A984U'
-- Log esecuzione
UPDATE LOG_ESECUZIONE
SET	Fine = GETDATE(),Tipo = 'UPDATE',Righe = @@ROWCOUNT
WHERE Nome = 'RP_DM_GestioneEmail - SollecitiNOMIG' AND Inizio = (SELECT MAX(Inizio) FROM LOG_ESECUZIONE WHERE Nome = 'RP_DM_GestioneEmail - SollecitiNOMIG')
INSERT INTO LOG_ESECUZIONE (Nome, Inizio, Nota)
	VALUES ('RP_DM_GestioneEmail - Mail Revoca',GETDATE(),'Elaborazione giornaliera')
-- 3. INSERIMENTO MAIL "REVOCA"
-- TUPLE DA PERFEZIONARE SU CONTRATTOSEI
-- E PRESENTI SU GESTIONE_EMAIL
-- IL PB NON HA EFFETTUATO LA MIGRAZIONE DOPO @MaxInvioSoll SOLLECITI
-- N.B. OCCHIO ALLA CONDIZIONE -> (c6.clienteMigrato = 'N' AND numSolleciti = @MaxInvioSoll) OR  numSolleciti > @MaxInvioSoll
--		OVVERO: BUONA LA MIGRAZIONE EFFETTUATA DOPO L'ULTIMO SOLLECITO MA NON DOPO LA PRIMA REVOCA
INSERT INTO C6Mart.GESTIONE_EMAIL
	(Rete,Cod_Fiscale,Tipo,Data_Generazione,ID_ELAB)
SELECT  
	email.rete,
	email.cod_fiscale,
	'REVOCA_NOMIG' as tipoEmail,
	getDate() as DataGenerazione,
	@ID_ELAB AS ID_ELAB --max(Data_Generazione)
FROM C6Mart.vcontratti VC
INNER JOIN [C6Mart].[CONTRATTOSEI_METADATI] MD
		ON MD.chiaveclientepb = VC.chiaveclientepb
INNER JOIN c6mart.gestione_Email EMAIL
	ON VC.RETE = EMAIL.RETE
	AND VC.COD_FISCALE = EMAIL.COD_FISCALE
LEFT JOIN C6MART.CODICI_PROMOTORI_FITTIZI PF
	ON VC.COD_AGENTE BETWEEN PF.CODICEDA AND PF.CODICEA
	AND VC.RETE = PF.RETE
WHERE 1 = 1
	AND EMAIL.Tipo IN ('S_SOLL_NOMIG','REVOCA_NOMIG')	
	AND (
			(MD.numRevoche> 0) -- SONO NEL CASO DI REVOCA SUCCESSIVA BRAVO VALERIO
			OR 
			(MD.numSolleciti = @MaxInvioSoll and MD.clienteMigrato = 'N')-- SONO NEL CASO DI PRIMA REVOCA
		)
	AND VC.Data_FineAvanzato > getDate()
	--AND VC.GenerazioneReport = 'S'
	AND (DATEDIFF(DAY,isnull(MD.Data_UltimaRevoca,MD.Data_UltimoSollecito),GETDATE()) >= @NUMGIORNIDASOLLECITO)
	AND PF.RETE IS NULL
    AND VC.COD_FISCALE = 'TSSDNI82P44A984U'
GROUP BY email.rete, email.cod_fiscale
-- 3.BIS UPDATE CONTRATTOSEI DOPO INSERIMENTO MAIL "REVOCA"
-- AUMENTIAMO IL NUMERO numSolleciti
-- NON AGGIORNIAMO LA DATA Data_UltimoSollecito
-- N.B. VERIFICARE SE IL CAMPO Data_UltimoSollecito VA AGGIORNATO
UPDATE c6mart.[CONTRATTOSEI_METADATI]
SET 
	numRevoche = isnull(numRevoche,0) + 1,
	data_UltimaRevoca = getDate()
FROM C6Mart.vcontratti VC
INNER JOIN [C6Mart].[CONTRATTOSEI_METADATI] MD
		ON MD.chiaveclientepb = VC.chiaveclientepb
INNER JOIN c6mart.gestione_Email EMAIL
	ON VC.RETE = EMAIL.RETE
	AND VC.COD_FISCALE = EMAIL.COD_FISCALE
LEFT JOIN C6MART.CODICI_PROMOTORI_FITTIZI PF
	ON VC.COD_AGENTE BETWEEN PF.CODICEDA AND PF.CODICEA
	AND VC.RETE = PF.RETE
WHERE 1 = 1
	AND EMAIL.Tipo IN ('S_SOLL_NOMIG','REVOCA_NOMIG')	
	AND (
			(MD.numRevoche> 0) -- SONO NEL CASO DI REVOCA SUCCESSIVA BRAVO VALERIO
			OR 
			(MD.numSolleciti = @MaxInvioSoll and MD.clienteMigrato = 'N')-- SONO NEL CASO DI PRIMA REVOCA
		)
	AND VC.Data_FineAvanzato > getDate()
	--AND VC.GenerazioneReport = 'S'
	AND (DATEDIFF(DAY,isnull(MD.Data_UltimaRevoca,MD.Data_UltimoSollecito),GETDATE()) >= @NUMGIORNIDASOLLECITO)
	AND PF.RETE IS NULL
	AND VC.COD_FISCALE = 'TSSDNI82P44A984U'	
-- Log esecuzione
UPDATE LOG_ESECUZIONE
SET Fine = GETDATE(),Tipo = 'INSERT',Righe = @@ROWCOUNT
WHERE Nome = 'RP_DM_GestioneEmail - Mail Revoca' AND Inizio = (
		SELECT MAX(Inizio) FROM	LOG_ESECUZIONE WHERE Nome = 'RP_DM_GestioneEmail - Mail Revoca')
COMMIT
END